@echo off
::----------------------------------------------------------------------
:: This BAT file will help you to update your templates according to
:: the new DocFlex/Javadoc version or new license you are using now
::----------------------------------------------------------------------

::----------------------------------------------------------------------
:: Specify the location of JDK 7.x, 6.x, 5.x or 1.4.x here
::----------------------------------------------------------------------
set JDK_HOME=C:\Program Files\Java\jdk1.7

::----------------------------------------------------------------------
:: Specify the location of DocFlex/Javadoc home directory.
::
:: If you encounter an error like:
:: 'Exception in thread "main" java.lang.NoClassDefFoundError: com/docflex/javadoc/Designer'
:: please specify directly the absolute pathname of your DocFlex/Javadoc installation, e.g.
::
:: set DFH=C:\docflex-javadoc
::
:: The default setting (below) assigns 'DFH' with the absolute pathname of 
:: this BAT file's parent directory
::----------------------------------------------------------------------
set DFH=%~dp0

::----------------------------------------------------------------------
:: Get rid of the trailing slash in 'DFH', if present
::----------------------------------------------------------------------
if %DFH:~-1%==\ set DFH=%DFH:~0,-1%

::----------------------------------------------------------------------
:: DocFlex/Javadoc class path
::----------------------------------------------------------------------
set CLASS_PATH=%JDK_HOME%\lib\tools.jar;%DFH%\lib\docflex-javadoc.jar

::----------------------------------------------------------------------
:: Please specify the location of your templates here.
:: Add -r option to include all the template directory subtree
::----------------------------------------------------------------------
set DOCFLEX_OPTIONS=-updatetemplates "%DFH%\templates" -r

::----------------------------------------------------------------------
:: Run template designer to update templates
:: (Note: double quotes are needed because file pathnames may contain spaces)
::----------------------------------------------------------------------
"%JDK_HOME%\bin\java" -cp "%CLASS_PATH%" com.docflex.xml.Designer %DOCFLEX_OPTIONS%
pause